package org.example.data.admin

import io.github.serpro69.kfaker.Faker
import org.example.domain.entity.User
import org.example.domain.request.UserAuthorizeRequest
import org.example.domain.request.UserRegistrationRequest
import java.util.*

data class LocalUser(
    val uuid: UUID,
    var lastname: String,
    var firstname: String? = null,
    var email: String,
    var url: String? = null,
    var password: String,
    var phone: String? = null
)
val users = generateUsers(100).toMutableList()
fun generateUsers(userCount: Int): List<LocalUser>{
    val localUserList = mutableListOf<LocalUser>()
    val faker = Faker()
    repeat(userCount){
        localUserList.add(
            LocalUser(
                uuid = UUID.randomUUID(),
                lastname = faker.name.lastName(),
                firstname = faker.name.firstName(),
                email = faker.random.randomString(3)+"@mail.ru",
                url = faker.random.randomString(10),
                password = faker.random.randomString(8),
                phone = faker.phoneNumber.phoneNumber()
            )
        )

    }
    return localUserList
}

fun authorize(userAuthorizeRequest: UserAuthorizeRequest): User{
    val findUser = users.firstOrNull { it.email == userAuthorizeRequest.email }
    checkNotNull(findUser){
        "Пользователь не найден"
    }
    return if (findUser.password == userAuthorizeRequest.password) User(
        uuid = findUser.uuid,
        email = findUser.email,
        lastname = findUser.lastname,
        firstname = findUser.firstname,
        url = findUser.url,
        phone = findUser.phone
    )
    else throw IllegalArgumentException("Пароли не совпадают")
}

fun registration(userRegistrationRequest: UserRegistrationRequest):User{
    val user = LocalUser(
        uuid = UUID.randomUUID(),
        lastname = userRegistrationRequest.lastname,
        email = userRegistrationRequest.password,
        password = userRegistrationRequest.password
    )
    users.add(user)
    return User(
        uuid = user.uuid,
        lastname = user.lastname,
        email = user.email
    )
}